// JavaScript Document
//networkstatus.js

var CONST_DEVICE_SIGNAL_4G=4;
var CONST_DEVICE_SIGNAL_3G=3;
var CONST_DEVICE_SIGNAL_2G=2;

var CONST_NETWORKTYTES = {
    0: system_no_network_type,
    1: system_network_gsm,
    2: system_network_gprs,
    3: system_network_edge,
    4: system_network_wcdma,
    5: system_network_hsdpa,
    6: system_network_hsupa,
    7: system_network_hspa,
    8: system_network_td_scdma,
    9: system_network_hspaw,
    10: system_network_evd0,
    11: system_network_evda,
    12: system_network_evdb,
    17: system_network_hspaw,
    18: system_network_hspaw,
    19: system_network_lte,
    46: system_network_dc_hspa_plus
};

var CONST_CSPS_STATES={
    0: system_no_network,
    1: system_register_on_the_local_network,
    2: system_being_registered_in,
    3: system_registation_is_benied,
    4: system_for_unknown_reasons,
    5: system_registered_roaming_network
};

var CONST_PS_ATTACH={
    0: system_device_detachment,
    1: system_device_attachment
};


function fun_isValidType(inputType,defaultType) {
    if(typeof(inputType) == 'undefined' || '' == $.trim(inputType)) {
        return defaultType;
    } else {
        return inputType;
    }
}

function update_networkStatus_allInfo(){
    addStatusListener('get_networkStatus_monitoringStatus()');
    addStatusListener('get_networkStatus_networkName()');
    addStatusListener('get_networkStatus_csps_state()');
    addStatusListener('get_networkStatus_signal()');
    
}

function get_networkStatus_networkName(){
    getAjaxData("api/net/current-plmn", function($xml){
        var t_ret = xml2object($xml);
        if (t_ret.type == "response") 
        {
           if(t_ret.response.ShortName != ""){
		       $("#idvalue_network_name").html(t_ret.response.ShortName);
		   }else{
		       $("#idvalue_network_name").html(common_unknown);
		   }
        }
        else 
        {
            log.error("api/net/current-plmn failed");
        }
    });
}

function get_networkStatus_monitoringStatus(){
    if(typeof G_MonitoringStatus!="undefined" && G_MonitoringStatus!=null){
        var t_ret=G_MonitoringStatus.response;
        
        if(t_ret.ServiceStatus == SERVICE_STATUS_AVAIABLE){
            var t_type_index=parseInt(t_ret.CurrentNetworkType,10);
            var t_text=fun_isValidType(CONST_NETWORKTYTES[t_type_index], common_unknown);
            $("#idvalue_network_type").html(t_text);
            
            if(t_ret.WanIPAddress != ""){
              $("#idvalue_ip_address").html(t_ret.WanIPAddress);
            }else{
               $("#idvalue_ip_address").html(common_unknown);
            }
            
            if(t_ret.PrimaryDns != ""){
              $("#idvalue_dns_server").html(t_ret.PrimaryDns);
            }else{
               $("#idvalue_dns_server").html(common_unknown);
            }
        }
        else{
            $("#idvalue_network_type").html(common_unknown);
            $("#idvalue_ip_address").html(common_unknown);
            $("#idvalue_dns_server").html(common_unknown);
        }
        
        
    }
}

function get_networkStatus_csps_state(){
    getAjaxData("api/net/csps_state", function($xml){
        var t_ret = xml2object($xml);
        if (t_ret.type == "response") 
        {
            var t_csstate_index=parseInt(t_ret.response.csstate,10);
            var t_text_cs=fun_isValidType(CONST_CSPS_STATES[t_csstate_index], common_unknown);
            $("#idvalue_network_cs_regist").html(t_text_cs);
            
            var t_psstate_index=parseInt(t_ret.response.psstate,10);
            var t_text_ps=fun_isValidType(CONST_CSPS_STATES[t_psstate_index], common_unknown);
            $("#idvalue_network_ps_regist").html(t_text_ps);
        }
        else 
        {
            log.error("api/net/csps_state failed");
        }
    });
}

function get_networkStatus_signal() {
    getAjaxData('api/device/signal', function($xml) {
        var t_ret = xml2object($xml);
        if (t_ret.type == "response") 
        {
           if(t_ret.response.rssi != ""){
		       $("#idvalue_network_rssi").html(t_ret.response.rssi);
		   }else{
		       $("#idvalue_network_rssi").html(common_unknown);
		   }
           
           if(t_ret.response.cellid != ""){
		       $("#idvalue_cell_id").html(t_ret.response.cellid);
		   }else{
		       $("#idvalue_cell_id").html(common_unknown);
		   }
           
           var t_psattach_index=parseInt(t_ret.response.psatt,10);
           var t_text_psattach=fun_isValidType(CONST_PS_ATTACH[t_psattach_index], common_unknown);
           $("#idvalue_network_attachment").html(t_text_psattach);
           
           if(CONST_DEVICE_SIGNAL_4G==t_ret.response.mode){
                fun_show_4g_info();
           }else if(CONST_DEVICE_SIGNAL_3G==t_ret.response.mode){
                fun_show_3g_info();
           }else{
                fun_show_2g_info();
           }
           if(t_ret.response.rscp != ""){
		       $("#idvalue_network_rscp").html(t_ret.response.rscp);
		   }else{
		       $("#idvalue_network_rscp").html(common_unknown);
		   }
           
           if(t_ret.response.rsrp != ""){
		       $("#idvalue_network_rsrp").html(t_ret.response.rsrp);
		   }else{
		       $("#idvalue_network_rsrp").html(common_unknown);
		   }
           
           if(t_ret.response.rsrq != ""){
		       var t_rsrq=t_ret.response.rsrq.replace('m','');
               $("#idvalue_network_rsrq").html(t_rsrq);
		   }else{
		       $("#idvalue_network_rsrq").html(common_unknown);
		   }
           
           if(t_ret.response.pci != ""){
		       $("#idvalue_network_pci").html(t_ret.response.pci);
		   }else{
		       $("#idvalue_network_pci").html(common_unknown);
		   }
        }
        else 
        {
            log.error("api/device/signal failed");
        }
    });
}

//4g
function fun_show_4g_info(){
    $("#idtr_cs_regist").hide();
    $('#idtr_rscp').hide();
    $('#idtr_rsrp').show();
    $('#idtr_rsrq').show();
    $('#idtr_pci').show();
}

//3g
function fun_show_3g_info(){
    $("#idtr_cs_regist").show();
    $('#idtr_rscp').show();
    $('#idtr_rsrp').hide();
    $('#idtr_rsrq').hide();
    $('#idtr_pci').hide();
}

//2g
function fun_show_2g_info(){
    $("#idtr_cs_regist").show();
    $('#idtr_rscp').hide();
    $('#idtr_rsrp').hide();
    $('#idtr_rsrq').hide();
    $('#idtr_pci').hide();
}
update_networkStatus_allInfo();